#include		"windows.h"
#include		"sq.h"
#include		"sqWin32Args.h"

#include		"KernelPlugin.h"
#include		"PlugManPlugin.h" 
#include		"ModManPlugin.h" 
#include		"SecurityPlugin.h" 
#include		"PlatformPlugin.h"
#include		"WindowPlugin.h"


static struct KernelProxy					*kernelProxy ;
static struct PlatformProxy				*platformProxy ;
static struct WindowProxy				 	*windowProxy ;
static struct PlugManProxy				*plugManProxy ;
static struct VirtualMachine			*interpreterProxy ;
static struct	SecurityProxy				*securityProxy ;
static struct ModManProxy					*modManProxy ;

# define XNAME(string) ModManPlugin_##string

static const char *moduleName = "ModManPlugin August 2001" ;
static	char*		reqPlugins[] = {"MicroKernel", "PlatformPlugin", "WindowPlugin", "InterpreterPlugin", NULL} ;

#pragma export on
/* module initialization/shutdown */
EXPORT(int) XNAME(setKernelProxy)(struct KernelProxy *aProxy);
EXPORT(const char*) XNAME(getModuleName)(void);
EXPORT(int) XNAME(initialiseModule)(void);
EXPORT(int) XNAME(shutdownModule)(void);
#pragma export off

EXPORT(int) XNAME(initialiseModule)() 
{
	if( !initObjectMemoryStartup(kernelProxy) )
		return 0 ;
	
	return 1 ;
}

EXPORT(const char*) XNAME(getModuleName)(void) {
	return moduleName;
}

EXPORT(int) XNAME(shutdownModule)() {
	return 1;
}

int XNAME(startupModule)() {
	return 1 ;
}

char** XNAME(getRequiredPlugins)() {
	return (char**)reqPlugins ;
}

EXPORT(int) XNAME(setKernelProxy)(struct KernelProxy *aProxy)
{
	if(NULL != modManProxy)
		return modManProxy ;

	kernelProxy = aProxy ;

	modManProxy = sqGetModManProxy() ;

	return modManProxy ;
}

struct GenericPlugin*		getModManGenericPlugin(void)
{
	struct	GenericPlugin*	genericPlugin ;
	void*		funcs[5] ;

	funcs[0] = ModManPlugin_getModuleName ;    
	funcs[1] = ModManPlugin_initialiseModule ; 
	funcs[2] = ModManPlugin_startupModule ; 
	funcs[3] = ModManPlugin_shutdownModule ;   
	funcs[4] = ModManPlugin_getRequiredPlugins ;   

	genericPlugin = kernelProxy->plugManProxy->newGenericPlugin(funcs, NULL) ;

	return genericPlugin ;
}


struct ModManProxy	*sqGetModManProxy(void)
{
	static ModManProxy			*modManProxy = NULL ;

	if(NULL != modManProxy) 
		return modManProxy ;

	modManProxy = (struct ModManProxy *) calloc(1, sizeof(ModManProxy));

	modManProxy->genericPlugin = getModManGenericPlugin() ;

	return modManProxy ;
} 
