#ifndef		PLATFORM_PLUGIN_H
#define		PLATFORM_PLUGIN_H
#include		<windows.h>

#ifndef		SQ_IMAGE_FILE
#define		SQ_IMAGE_FILE
typedef int sqImageFile;
#endif		// SQ_IMAGE_FILE

HINSTANCE		getInstance(void) ;
int					ioExit(void) ;
int					ioBeep(void) ;
int					ioSeconds(void);
int					ioMSecs(void);
int					ioMicroMSecs(void);
DWORD				convertToSqueakTime(SYSTEMTIME st) ;
TCHAR*			fromSqueak(const char *sqPtr, int sqSize) ;
TCHAR*			fromSqueak2(const char *sqPtr, int sqSize)	;
void				printLastError(TCHAR *prefix) ;
char*				GetImageOption(int id) ;
char*				GetVMOption(int id) ;
void				printLastError(TCHAR *prefix) ;
char*				fromUnicode(const TCHAR *ptr) ;
TCHAR*			toUnicode(const char *ptr) ;
BOOL				getHeadlessImageFlag(void)	  ;
char*				getImageName(void) ;
TCHAR*			getVmPath(void) ;
TCHAR*			getVmName(void) ;
BOOL				getWindows95Flag(void)	  ;
BOOL				getRunServiceFlag(void)	;  
int					getThisSession(void) ;
TCHAR*			getImagePath(void) ;
TCHAR*			getSqueakIniName(void) ;
void				MsgBox(char *pszMsg, char *pszTitle) ;

int __cdecl abortMessage(const TCHAR* fmt, ...) ;
int __cdecl sqMessageBox(DWORD dwFlags, const TCHAR *titleString, const char* fmt, ...) ;

// int					synchronizedSignalSemaphoreWithIndex(int semaIndex);
// HANDLE*			getVmWakeUpEventAddress(void) ;
// void				setVmWakeUpEvent(HANDLE hEvent) ;
// HANDLE			getVmSemaphoreMutex(void) ;
// void				setVmSemaphoreMutex(HANDLE hMutex) ;
HWND				getBrowserWindow(void) ;
void				setBrowserWindow(HWND hWindow) ;
int					printUsage(int level) ;
sqImageFile	getImageFileHandle(void) ;
void				setImageFileHandle(sqImageFile handle) ;
void				setShowAllocationsFlag(BOOL aFlag) ;
BOOL				getShowAllocationsFlag(void) ;
BOOL				getBroadcastService95Flag(void) ;

int					vmPathSize(void)	;
int					vmPathGetLength(int sqVMPathIndex, int length) ;
int					imageNameSize(void) ;
int					imageNameGetLength(int sqImageNameIndex, int length) ;
int					imageNamePutLength(int sqImageNameIndex, int length) ;
int					OutputLogMessage(char *string) ;
TCHAR*			toUnicodeNew(const char *ptr) ;

sqImageFile sqImageFileOpen(char *fileName, char *mode) ;
int sqImageFileSeek(sqImageFile h, int pos) ;
int sqImageFileRead(void *ptr, int sz, int count, sqImageFile h) ;
int sqImageFileWrite(void *ptr, int sz, int count, sqImageFile h) ;
int sqImageFileSize(sqImageFile h) ;
int sqImageFilePosition(sqImageFile h) ;
int sqImageFileClose(sqImageFile h) ;
						
int readableFormat(int imageVersion) ;				// From interp.c
int byteSwapped(int w) ;											// From interp.c


typedef struct PlatformProxy 
{
	struct GenericPlugin	*genericPlugin	 ;

	int					(*ioExit)(void) ;
	int					(*ioBeep)(void) ;
	int					(*ioSeconds)(void);
	int					(*ioMSecs)(void);
	int					(*ioMicroMSecs)(void);

	int					(*getThisSession)(void) 	;
	HINSTANCE		(*getInstance)(void) ;
	
	BOOL				(*getBroadcastService95Flag)(void) ;
	BOOL				(*getHeadlessImageFlag)(void)	  ;
	BOOL				(*getWindows95Flag)(void)	  ;
	BOOL				(*getRunServiceFlag)(void)	;  
	
	void				(*setShowAllocationsFlag)(BOOL aFlag) ;
	BOOL				(*getShowAllocationsFlag)(void) ;

	HWND				(*getBrowserWindow)(void) ;
	void				(*setBrowserWindow)(HWND hWindow) ;

	int					(*getAttributeIntoLength)(int id, int byteArrayIndex, int length);
	int					(*attributeSize)(int id);

	int					(*vmPathSize)(void)	;
	int					(*vmPathGetLength)(int sqVMPathIndex, int length) ;
	char*				(*GetVMOption)(int id);

	int					(*imageNameSize)(void) ;
	int					(*imageNameGetLength)(int sqImageNameIndex, int length) ;
	int					(*imageNamePutLength)(int sqImageNameIndex, int length) ;
	char*				(*GetImageOption)(int id);

	int					(*readableFormat)(int imageVersion) ;				// From interp.c
	int					(*byteSwapped)(int w) ;											// From interp.c

	void				(*setImageFileHandle)(sqImageFile handle) ;
	sqImageFile	(*getImageFileHandle)(void) ;
	int					(*sqImageFilePosition)(sqImageFile h);
	int					(*sqImageFileSeek)(sqImageFile h, int pos);
	int					(*sqImageFileClose)(sqImageFile h);
	int					(*sqImageFileRead)(void *ptr, int sz, int count, sqImageFile h);
	int					(*sqImageFileWrite)(void *ptr, int sz, int count, sqImageFile h);
	sqImageFile (*sqImageFileOpen)(char *fileName, char *mode);

	TCHAR*			(*toUnicode)(const char *ptr);                 /* Inline Ansi -> Unicode */
	TCHAR*			(*toUnicodeNew)(const char *ptr) ;
	char*				(*fromUnicode)(const TCHAR *ptr);              /* Inline Unicode -> Ansi */
	TCHAR*			(*fromSqueak)(const char *sqPtr, int sqSize) ;
	TCHAR*			(*fromSqueak2)(const char *sqPtr, int sqSize) ;
	DWORD				(*convertToSqueakTime)(SYSTEMTIME st) ;
	
	void				(*LongFileNameFromPossiblyShortName)(TCHAR *nameBuffer) ;
	TCHAR*			(*lstrrchr)(TCHAR *source, TCHAR c) ;
	int					(*printUsage)(int level) ;
	int					(*OutputLogMessage)(char *string) ;
	void				(*printLastError)(TCHAR *prefix) ;
	int					(*sqMessageBox)(DWORD dwFlags, const TCHAR *titleString, const char* fmt, ...);
	int					(*abortMessage)(const TCHAR* fmt, ...) ;
	void				(*MsgBox)(char *pszMsg, char *pszTitle) ;

//	TCHAR*			(*getSqueakIniName)(void) ;

//	TCHAR*			(*getVmPath)(void) ;
//	TCHAR*			(*getVmName)(void) ;
//	TCHAR*			(*getImagePath)(void) ;
//	char*				(*getImageName)(void) ;

//	int				(*synchronizedSignalSemaphoreWithIndex)(int semaIndex);
//	HANDLE*		(*getVmWakeUpEventAddress)(void) ;
//	void			(*setVmWakeUpEvent)(HANDLE hEvent) ;
//	HANDLE		(*getVmSemaphoreMutex)(void) ;
//	void			(*setVmSemaphoreMutex)(HANDLE hMutex) ;
} PlatformProxy ;


struct PlatformProxy* sqGetPlatformProxy(void) ;

#endif			// PLATFORM_PLUGIN_H
