#ifndef		PLUG_MAN_PLUGIN_H
#define		PLUG_MAN_PLUGIN_H

#include		<windows.h>

ModuleEntry *firstModule ;
ModuleEntry *ioGetPluginModuleEntry(char *pluginName) ;

int			ioLoadFunctionFrom(char *fnName, char *modName);
int			ioLoadExternalFunctionOfLengthFromModuleOfLength(
													int functionNameIndex, int functionNameLength,
													int moduleNameIndex, int moduleNameLength);
int			ioLoadModuleOfLength(int modIndex, int modLength);
int			ioLoadSymbolOfLengthFromModule(int fnIndex, int fnLength, int handle);
char*		ioListBuiltinModule(int moduleIndex);
char*		ioListLoadedModule(int moduleIndex);
int			ioUnloadModuleOfLength(int moduleNameIndex, int moduleNameLength);
void*		ioGetPluginProxy(char *pluginName) ;
int			ioLoadModuleOfLength(int moduleNameIndex, int moduleNameLength) ;
int			ioFindExternalFunctionIn(char *lookupName, int moduleHandle) ;
int			ioFreeModule(int moduleHandle) ;
int			ioLoadModule(char *pluginName) ;
int			ioShutdownAllModules(void) ;
void		FreeModuleMemory(struct ModuleEntry *thisModule) ;
struct GenericPlugin	*sqGetGenericPlugin(void* funcs[], void* vers[]) ;

typedef struct PlugManProxy
{
	struct GenericPlugin	*genericPlugin	 ;

	void*						(*ioGetPluginProxy)(char *pluginName) ;
	void						(*setThisModuleProxy)(GenericProxy *aProxy) ;
	ModuleEntry*		(*ioGetPluginModuleEntry)(char *pluginName) ;
	GenericPlugin*	(*newGenericPlugin)(void* funcs[], void* vers[]) ;

	int							(*ioShutdownAllModules)(void) ;
	int							(*ioLoadFunctionFrom)(char *fnName, char *modName);
	int							(*ioLoadExternalFunctionOfLengthFromModuleOfLength)(
																			int functionNameIndex, int functionNameLength,
																			int moduleNameIndex, int moduleNameLength);
	int							(*ioLoadModuleOfLength)(int modIndex, int modLength);
	int							(*ioLoadSymbolOfLengthFromModule)(int fnIndex, int fnLength, int handle);
	char*						(*ioListBuiltinModule)(int moduleIndex);
	char*						(*ioListLoadedModule)(int moduleIndex);
	int							(*ioUnloadModuleOfLength)(int moduleNameIndex, int moduleNameLength);
	int							(*ioLoadModule)(char *pluginName) ;
	int							(*ioFreeModule)(int moduleHandle) ;
	int							(*ioFindExternalFunctionIn)(char *lookupName, int moduleHandle);
} PlugManProxy ;


struct PlugManProxy* sqGetPlugManProxy(void) ;

#endif			// PLUG_MAN_PLUGIN_H
