#ifndef		SECURITY_PLUGIN_H
#define		SECURITY_PLUGIN_H

/* security plugin header file */
#include "SocketPlugin.h"

/* image writing */
int ioDisableImageWrite(void);
int ioCanWriteImage(void);

/* untrusted and secure directory locations */
char *ioGetSecureUserDirectory(void);
char *ioGetUntrustedUserDirectory(void);

/* following must be called by the VM before interpret() */
int ioInitSecurity(void);

int _ioSetSocketAccess(int enable) ;
int _ioSetImageWrite(int enable) ;
int _ioSetFileAccess(int enable) ;

int ioCanRenameImage(void);
int ioHasFileAccess(void);
int ioCanOpenAsyncFileOfSizeWritable(char* fileNameIndex, int fileNameSize, int writeFlag);
int ioCanCreatePathOfSize(char* dirNameIndex, int dirNameSize);
int ioCanDeletePathOfSize(char* dirNameIndex, int dirNameSize);
int ioCanGetFileTypeOfSize(char* fileNameIndex, int fileNameSize);
int ioCanListPathOfSize(char* dirNameIndex, int dirNameSize);
int ioCanSetFileTypeOfSize(char* fileNameIndex, int fileNameSize);
int ioDisableFileAccess(void);
int ioCanDeleteFileOfSize(char* fileNameIndex, int fileNameSize);
int ioCanOpenFileOfSizeWritable(char* fileNameIndex, int fileNameSize, int writeFlag);
int ioCanRenameFileOfSize(char* fileNameIndex, int fileNameSize);

typedef struct SecurityProxy 
{
	struct GenericPlugin	*genericPlugin	 ;

	int (*ioInitSecurity)(void);
	int (*ioCanWriteImage)(void);
	int (*ioCanRenameImage)(void);
	int (*ioHasFileAccess)(void);
	int (*ioHasSocketAccess)(void);
	int (*ioCanOpenAsyncFileOfSizeWritable)(char* fileNameIndex, int fileNameSize, int writeFlag);
	int (*ioCanCreatePathOfSize)(char* dirNameIndex, int dirNameSize);
	int (*ioCanDeletePathOfSize)(char* dirNameIndex, int dirNameSize);
	int (*ioCanGetFileTypeOfSize)(char* fileNameIndex, int fileNameSize);
	int (*ioCanListPathOfSize)(char* dirNameIndex, int dirNameSize);
	int (*ioCanSetFileTypeOfSize)(char* fileNameIndex, int fileNameSize);
	int (*ioDisableFileAccess)(void);
	int (*ioCanDeleteFileOfSize)(char* fileNameIndex, int fileNameSize);
	int (*ioCanOpenFileOfSizeWritable)(char* fileNameIndex, int fileNameSize, int writeFlag);
	int (*ioCanRenameFileOfSize)(char* fileNameIndex, int fileNameSize);
	int (*ioDisableSocketAccess)(void);
	int (*ioCanConnectToPort)(int netAddr, int port);
	int (*ioCanCreateSocketOfType)(int netType, int socketType);
	int (*ioCanListenOnPort)(SocketPtr s, int port);
	int (*_ioSetSocketAccess)(int enable) ;
	int (*_ioSetImageWrite)(int enable) ;
	int (*_ioSetFileAccess)(int enable) ;

} SecurityProxy ;

#endif		// SECURITY_PLUGIN_H
