#ifndef _WINDOW_PLUGIN__H
#define _WINDOW_PLUGIN__H

#include <windows.h>

#include "JoystickTabletPlugin.h"

#ifndef		_struct_sqInputEvent_
#define		_struct_sqInputEvent_
/* generic input event definition */
typedef struct sqInputEvent {
	int type; /* type of event; either one of EventTypeXXX */
	unsigned int timeStamp; /* time stamp */
     /* the interpretation of the following fields depend on the type of the event */
	int unused1;
	int unused2;
	int unused3;
	int unused4;
	int unused5;
	int unused6;
} sqInputEvent;
#endif		// _struct_sqInputEvent_

// int ioBeep(void) ;
int clipboardReadIntoAt(int count, int byteArrayIndex, int startIndex);
int clipboardSize(void);
// int ioExit(void);

int ioForceDisplayUpdate(void) ;
int ioHasDisplayDepth(int depth) ;

// int ioMicroMSecs(void);
int ioProcessEvents(void) ;
int ioSetCursor(int cursorBitsIndex, int offsetX, int offsetY);
int ioSetCursorWithMask(int cursorBitsIndex, int cursorMaskIndex, int offsetX, int offsetY);
int ioShowDisplay(int dispBitsIndex, int width, int height, int depth,
								int affectedL, int affectedR, int affectedT, int affectedB);
int clipboardWriteFromAt(int count, int byteArrayIndex, int startIndex);
int ioDisablePowerManager(int disableIfNonZero);
int ioFormPrint(int bitsAddr, int width, int height, int depth,
								double hScale, double vScale, int landscapeFlag);
int getAttributeIntoLength(int id, int byteArrayIndex, int length);
int attributeSize(int id);
int ioGetNextEvent(sqInputEvent *evt);
// int imageNameGetLength(int sqImageNameIndex, int length);
// int imageNameSize(void);
// int imageNamePutLength(int sqImageNameIndex, int length);
int ioSetInputSemaphore(int semaIndex);
int ioGetKeystroke(void);
int ioPeekKeystroke(void);
int ioGetButtonState(void);
int ioMousePoint(void);
int ioRelinquishProcessorForMicroseconds(int microSeconds);
int startProfiling(void);
int stopProfiling(void);
int clearProfile(void);
int dumpProfile(void);
int ioScreenDepth(void);
int ioScreenSize(void);
int ioSeconds(void);
int ioSetDisplayMode(int width, int height, int depth, int fullscreenFlag);
int ioSetFullScreen(int fullScreen);
int ioHasDisplayDepth(int depth);
int vmPathGetLength(int sqVMPathIndex, int length);
int vmPathSize(void);
BOOL  fShowAllocations; /* Show memory allocations */
int thisModuleShouldNotBeUnloaded(char *moduleName) ;
// char *getBuiltinModule(int moduleIndex) ;
// int __cdecl sqMessageBox(DWORD dwFlags, const TCHAR *titleString, const char* fmt, ...) ;

BOOL getBrowserMode(void) ;
void setBrowserMode(BOOL bFlag) ;
BOOL getUseDirectSoundFlag(void) ;
void setUseDirectSoundFlag(BOOL bFlag) ;
// HINSTANCE	getInstance(void) ;
TCHAR	*getImagePath(void) ;
BOOL getShowAllocations(void) ;
TCHAR	*getSqueakIniName(void) ;
HWND	getStWindow(void) ;
// int getThisSession(void) ;
// char* getImageName(void) ;
HMENU getVmPrefsMenu(void) ;
void setShowConsoleFlag(BOOL bFlag) ;
BOOL getDynamicConsoleFlag(void) ;
HWND	getConsoleWindow(void) ;
int OutputConsoleString(char *string) ;
HPALETTE getPalette(void) ;
void SetWindowSize(void) ;
void SetupPixmaps(void) ;
void SetupKeymap(void) ;
void SetupWindows(void) ;
void SetWindowTitle(void) ;

typedef struct WindowProxy 
{
	struct GenericPlugin	*genericPlugin	 ;

	void			(*SetWindowTitle)(void) ;
	int				(*synchronizedSignalSemaphoreWithIndex)(int semaIndex);
	HANDLE*		(*getVmWakeUpEventAddress)(void) ;
	void			(*setVmWakeUpEvent)(HANDLE hEvent) ;
	HANDLE		(*getVmSemaphoreMutex)(void) ;
	void			(*setVmSemaphoreMutex)(HANDLE hMutex) ;
	void			(*SetWindowSize)(void) ;
	HPALETTE	(*getPalette)(void) ;
	int				(*OutputConsoleString)(char *string) ;
	HWND			(*getConsoleWindow)(void) ;
	BOOL			(*getDynamicConsoleFlag)(void)	;
	void			(*setShowConsoleFlag)(BOOL bFlag) ;
	HMENU			(*getVmPrefsMenu)(void) ;
	BOOL			(*getBrowserModeFlag)(void) ;
	void			(*setBrowserModeFlag)(BOOL bFlag) ;
	BOOL			(*getUseDirectSoundFlag)(void) ;
	void			(*setUseDirectSoundFlag)(BOOL bFlag) ;
	BOOL			(*getShowAllocations)(void) ;
	HWND			(*getStWindow)(void) ;
	messageHook* (*getPreMessageHookAddress)(void) ;

	int				(*clearProfile)(void);
	int				(*clipboardReadIntoAt)(int count, int byteArrayIndex, int startIndex);
	int				(*clipboardSize)(void);
	int				(*clipboardWriteFromAt)(int count, int byteArrayIndex, int startIndex);
	int				(*dumpProfile)(void);
	int				(*ioDisablePowerManager)(int disableIfNonZero);
	int				(*ioForceDisplayUpdate)(void);
	int				(*ioFormPrint)(int bitsAddr, int width, int height, int depth,
							 						double hScale, double vScale, int landscapeFlag);
	int				(*ioGetButtonState)(void);
	int				(*ioGetKeystroke)(void);
	int				(*ioGetNextEvent)(sqInputEvent *evt);
	int				(*ioHasDisplayDepth)(int depth);
	int				(*ioMousePoint)(void);
	int				(*ioPeekKeystroke)(void);
	int				(*ioProcessEvents)(void) ;
	int				(*ioRelinquishProcessorForMicroseconds)(int microSeconds);
	int				(*ioScreenDepth)(void);
	int				(*ioScreenSize)(void);
	int				(*ioSetCursor)(int cursorBitsIndex, int offsetX, int offsetY);
	int				(*ioSetCursorWithMask)(int cursorBitsIndex, int cursorMaskIndex, int offsetX, int offsetY);
	int				(*ioSetDisplayMode)(int width, int height, int depth, int fullscreenFlag);
	int				(*ioSetFullScreen)(int fullScreen);
	int				(*ioSetInputSemaphore)(int semaIndex);
	int				(*ioShowDisplay)(int dispBitsIndex, int width, int height, int depth,
							 							int affectedL, int affectedR, int affectedT, int affectedB);
	int				(*recordDragDropEvent)(HWND wnd, int dragType, int x, int y, int numFiles);
	int				(*startProfiling)(void);
	int				(*stopProfiling)(void);
	int				(*tabletGetParameters)(int cursorIndex, int result[]) ;
	int				(*tabletRead)(int cursorIndex, int result[]) ;
	int				(*tabletResultSize)(void) ;
//	int				(*imageNamePutLength)(int sqImageNameIndex, int length);
// 	int				(*imageNameGetLength)(int sqImageNameIndex, int length);
//	int				(*ioExit)(void);
//	int				(*vmPathGetLength)(int sqVMPathIndex, int length);
//	int				(*vmPathSize)(void);
// 	int				(*sqMessageBox)(DWORD dwFlags, const TCHAR *titleString, const char* fmt, ...) ;
//	int				(*attributeSize)(int id);
//	int				(*getAttributeIntoLength)(int id, int byteArrayIndex, int length);
//	int				(*imageNameSize)(void);
//	int				(*ioBeep)(void) ;
} WindowProxy ;

WindowProxy * sqGetWindowProxy() ;

#endif		// _WINDOW_PLUGIN__H
